<template>
  <div style="margin: 3rem">
    <header style="margin:10rem 6rem 3rem 6rem">
      <ReturnButton :offsetArrow="21" :spanTitle="2" title="Regresar" v-on:clickEvent="returnPage" style="margin-bottom:2.5rem"></ReturnButton>
      <el-row :gutter="20">
        <!-- BUSCADOR --> 
        <el-col :span="6" :offset="18">
          <app-search-filter v-model="textSearch"></app-search-filter>
        </el-col>  
      </el-row>
    </header>

   <!-- COMPONENTE TITULO -->
    <div style="margin:3rem 6rem">
      <app-title :Title="'RECEPCIÓN DE '+ typeContent + ' TELEVISA'" > </app-title>
    </div>


    <!-- Leyenda -->
    <div style="margin:3rem 6rem">
      <el-row>
        <el-col :span="22" :offset="1">
          <h5 style="margin: 2rem 0"> ESTADO DE LOS MATERIALES </h5>
        </el-col>
      </el-row>
      
      <DescriptionStateOrders v-if="typeContent == 'LARGOMETRAJES' || typeContent == 'MINISERIES'"
                              :TextSquareBlue="''" :TextSquareOrange="''" :TextSquareGray="'Pendiente'" :TextSquarePurple="''"
                              :TextSquareRed="'Pendiente de Reposición'" :TextSquareGreen="'Recibido'" :colBoxes="6"> 
      </DescriptionStateOrders>
      <DescriptionStateOrders v-else-if="typeContent == 'NOVELAS' || typeContent == 'SERIES' || typeContent == 'DIBUJOS'"
                              :TextSquareBlue="''" :TextSquareOrange="''" :TextSquareGray="'No se ha ingresado ningún capítulo'" :TextSquarePurple="''"
                              :TextSquareRed="'Capítulos incompletos'" :TextSquareGreen="'Capítulos completos'"> 
      </DescriptionStateOrders>
      <el-row type="flex" justify="space-between" v-else>
        <el-col :span="24">
          <el-row>
            <el-col :span="11" :offset="1">
              <h4 style="margin-bottom: 10px">{{typeContent}} SIN CAPÍTULOS</h4>
              <div style="margin: 8px 0" v-for="(item, index) in withoutCaps" :key="index">
                <div class="flex element-bloq-center" > 
                  <div :class="item.style" class="border-radius-light" style="margin-right:1rem; height:25px; width:25px"></div> 
                  <span>{{item.name}}</span>
                </div>
              </div>
            </el-col>
            <el-col :span="10" :offset="2">
              <h4 style="margin-bottom: 10px">{{typeContent.toUpperCase()}} CON CAPÍTULOS</h4>
              <div style="margin: 8px 0" v-for="(item, index) in withCaps" :key="index">
                <div class="flex element-bloq-center" > 
                  <div :class="item.style" class="border-radius-light" style="margin-right:1rem; height:25px; width:25px"></div> 
                  <span>{{item.name}}</span>
                </div>
              </div>
            </el-col>
          </el-row>
        </el-col>
      </el-row>
    </div>

    <!--COMPONENTE CARDS -->
    <div style="margin:6rem 6rem">
      <el-row :gutter="80">
        <el-col :span="12" v-for="(item, index) in materials.slice(0,30)" :key="index" style="margin-bottom: 3rem"> 
           <CardSuport 
              :stateOrder="item.stateBtnSupport" :numberOrder="' '" :originalTitle="item.listTitle"
              :colorButton="item.colorBtnSupport" :codMaterial="item.codMaterial" :titleToShow="theTitleIs(item)" :dataToShow="dataIs(item)"
              @eventEmit="changeRoute(item.__id, item, index, 'new')" />        
        </el-col>
      </el-row>
    </div>
  </div>
</template>

<script>

  import ReturnButton from '@/components/ReturnButton.vue'
  import Title from '@/components/Title.vue'    
  import SearchFilter from '@/components/searchFilter.vue'
  import { modifyText } from '../../../../utils/modifyText.js'
  import DescriptionStateOrders from '@/components/DescriptionStateOrders.vue' 
  import CardSuport from '@/components/CardSuport.vue'
  import { HTTP } from '../../../../main.js'
  import Select from '@/components/AppSelect.vue'
 

  export default {
    components: {
      ReturnButton,
      CardSuport,
      'app-search-filter': SearchFilter, 
      'app-title': Title,
       DescriptionStateOrders,
      'app-select': Select,
    },

    data () {
      return {
        nameView : this.$localStorage.get('nameView'),
        textSearch: '',
        typeMaterialSelected: localStorage.getItem('typeMaterialSelected'),
        typeContent: localStorage.getItem('typeContent'),
        totalMaterials: [],
        televisaMat: [],
        // links: [],
        originalTitle: '',
        filterSelect: '',
        withCaps: [
          {style: 'l-grey', name: 'No se ha ingresado ningún capítulo'},
          {style: 'bg-red', name: 'Capítulos Incompletos'},
          {style: 'l-green', name: 'Capítulos Completos'}
        ],
        withoutCaps: [
          {style: 'l-grey', name: 'Pendiente'},
          {style: 'bg-red', name: 'Pendiente de Reposición'},
          {style: 'l-green', name: 'Recibido'}
        ]
      };
    },
    created() {
      
      if(this.typeMaterialSelected == 'Especial'){
        this.getMaterialAffiliate('TELEVISA - ESPECIALES')
      } else if(this.typeMaterialSelected == 'Novelas'){
        this.getMaterialAffiliate('TELEVISA - TELENOVELAS')
      } else if(this.typeMaterialSelected == 'Series'){
        this.getMaterialAffiliate('TELEVISA - SERIES')
      }
      this.getMaterials()
    },
    methods: {
      orderDataByGeminisCode (array) {
        array.sort(function (a, b) {
          if ( Number(a.geminisCode) < Number(b.geminisCode) ) {
            return 1;
          }
          if ( Number(a.geminisCode) > Number(b.geminisCode )) {
            return -1;
          }
          return 0;
        });
        return array
      },
      getMaterialAffiliate(material){
        HTTP.get('materials/materialType/'+material)
        .then(res => {
          this.televisaMat = this.orderDataByGeminisCode(res.data.materials)
        })
        .catch(err => {
          console.log(err);
        });
      },
      getMaterials () {
        
        console.log(this.typeMaterialSelected, 'this.typeMaterialSelected')
        // HTTP.get('materials/typeOfContent/' + this.typeMaterialSelected +  '/materialType/Televisa')
        HTTP.get('materials/materialType/Televisa/typeOfContent/' + this.typeMaterialSelected + '/canned/true')
        // HTTP.get('materials/materialType/Televisa/typeOfContent/' + this.typeMaterialSelected + '/canned/false')
        .then(res => {
          this.totalMaterials = this.orderDataByGeminisCode(res.data.materials) 
          console.log(this.totalMaterials, 'this.totalMaterials')
        })
        .catch(err => console.log(err))
      },
      // querySearch(queryString, cb) {
      //   var links = this.links;
      //   var results = queryString ? links.filter(this.createFilter(queryString)) : links;
      //   console.log(results, 'results')
      //   cb(results);
      // },
      // createFilter(queryString) {
      //   return (link) => {
      //     return (link[this.filterSelect].toLowerCase().indexOf(queryString.toLowerCase()) !== -1);
      //   };
      // },
      // handleSelect(item) {
      //   this.originalTitle = item[this.filterSelect]
      //   this.materials = item
      // },
      changeRoute(id, item, index, text) {
        this.$localStorage.set('idSupportMat', JSON.stringify(id))
        this.$localStorage.set('stateBtnSup', JSON.stringify(item.stateBtnSupport))
        this.$localStorage.set('itemTelevisa', JSON.stringify(item))

          // var objeto = { 
          //   arrivalDate: '',
          //   shippingMode: "",
          //   guideNumber: "",
          //   radio: "Pendiente",
          //   support: "",
          //   replacementReposition: false,
          //   replacementStorage: false,
          //   stateReplacement: '',
          //   reposicion: [],
          //   stateStorage: 'Pendiente',
          //   copyBackUpStorage: '',
          //   dateCopy: '',
          //   storage: '',
          //   videoteca: '',
          //   typeStorage:  [{ typeStorage: '', codeDisk: '' }]
          // }

        if(item.numChapters.length ==  0) {
        //   if(item.storageMat.length == 0) {
        //     // item.storageMat.push(objeto) 
        //     item.infoSupport.push(objeto) 
        //   }
        //  this.$localStorage.set('itemTelevisa', JSON.stringify(item))
          this.$router.push({ name: 'recepcionSinCap' })

        }
        else {
          this.$router.push({ name: 'formTelevisa' })

        }
      },
      returnPage () {
        this.$router.push({name: 'Televisa'})
      },
      theTitleIs(value) {
        if(value.numChapters.length > 0) {
          return 'Temporada'
        } else {
          return 'Fecha de Llegada'
        }
      },
      dataIs(value) {
        if(value.numChapters.length > 0) {
          return (value.numChapters.map(i => i.season)).join(' - ')
        } else {
          return value.infoSupport.length > 0 && value.infoSupport[0].arrivalDate !== '' ? new Date(value.infoSupport[0].arrivalDate).toLocaleDateString('en-GB') : ''
        }
      }
    },
    computed: {
      // materials: { 
      //   get: function () {
      //   let mShow = this.totalMaterials
      //     if (this.textSearch == '' && this.originalTitle == '') {
      //       mShow = this.links
      //     }
      //     return mShow
      //   },
      //   set: function (newItem) {    
      //     let array = []
      //     array.push(newItem)
      //     this.totalMaterials = array
      //   }
      // }
      materials () {
        let materials 
        if(this.typeMaterialSelected == 'Especial' || this.typeMaterialSelected == 'Novelas' || this.typeMaterialSelected == 'Series'){
          // materials = this.televisaMat
					materials = this.totalMaterials.concat(this.televisaMat)
				} else {
					materials = this.totalMaterials
				}

        if (this.textSearch) {
          materials = materials.filter(
            m => modifyText(m.originalTitle).indexOf(modifyText(this.textSearch)) > -1) ||
                modifyText(m.ownTitle).indexOf(modifyText(this.textSearch)) > -1 ||
                modifyText(m.listTitle).indexOf(modifyText(this.textSearch)) > -1 
        }
        console.log(materials, 'materials')
        return materials
      }
    },
  }
</script>